# Get Started {#get_started}

@sphinxdirective

.. toctree::
   :maxdepth: 1
   :hidden:
   :caption: Install OpenVINO
   
   Overview <openvino_docs_install_guides_overview>
   Install OpenVINO Runtime <openvino_docs_install_guides_install_runtime>
   Install OpenVINO Development Tools <openvino_docs_install_guides_install_dev_tools>
   Build from Source <https://github.com/openvinotoolkit/openvino/wiki/BuildingCode>
   Create a Yocto Image <openvino_docs_install_guides_installing_openvino_yocto>
   Uninstalling <openvino_docs_install_guides_uninstalling_openvino>

.. toctree::
   :maxdepth: 1
   :hidden:
   :caption: Additional Configurations
   
   Configurations for GPU <openvino_docs_install_guides_configurations_for_intel_gpu>
   Configurations for NCS2 <openvino_docs_install_guides_configurations_for_ncs2>
   Configurations for VPU <openvino_docs_install_guides_installing_openvino_ivad_vpu>
   
.. toctree::
   :maxdepth: 1
   :hidden:
   :caption: Troubleshooting
   
   Troubleshooting Guide <openvino_docs_get_started_guide_troubleshooting>
   
.. toctree::
   :maxdepth: 1
   :hidden:
   :caption: Get Started Guides
   
   Get Started with Step-by-step Demo <openvino_docs_get_started_get_started_demos>
   Get Started with Tutorials <tutorials>

.. toctree::
   :maxdepth: 1
   :hidden:
   :caption: OpenVINO Code Samples

   openvino_docs_IE_DG_Samples_Overview


@endsphinxdirective
 
@sphinxdirective
.. raw:: html
    
   <link rel="stylesheet" type="text/css" href="_static/css/getstarted_style.css">
   
   <p>To get started with OpenVINO, the first thing to do is to actually install it. You can get an <a href="openvino_docs_install_guides_overview.html" >overview</a> of what installation options we provide and start from there. </p>
   
   <p id="GSG_introtext">If you already have enough information, you can also choose the installation type that best suits your needs from one of the options below:<br />
     <a href="openvino_docs_install_guides_install_runtime.html" >Install <br />OpenVINO Runtime </a>
     <a href="openvino_docs_install_guides_install_dev_tools.html" >Install OpenVINO <br />Development Tools</a>
     <a href="https://github.com/openvinotoolkit/openvino/wiki/BuildingCode" >Build <br /> from source</a>
   </p>
   <div style="clear:both;"> </div> 
   
   <p>If you are using Intel® Processor Graphics, Intel® Vision Accelerator Design with Intel® Movidius™ VPUs or Intel® Neural Compute Stick 2, please check the additional configurations for them accordingly: <a href="openvino_docs_install_guides_configurations_for_intel_gpu.html" >Configurations for GPU</a>, <a href="openvino_docs_install_guides_installing_openvino_ivad_vpu.html" >Configurations for VPU</a> or <a href="openvino_docs_install_guides_configurations_for_ncs2.html" >Configurations for NCS2</a>.
   </p>
   
   <p>With OpenVINO installed, you are ready to run your first inference and learn the workflow. <br /> Here is a set of hands-on demonstrations of various complexity levels to guide you through the process: from performing sample inference with just one command, to running code samples, demo application or Jupyter notebooks. If you prefer working with GUI, you can also get started with the DL Workbench application. This way you can choose the right level for you.<br /></p>
 
   <h3>Choose how you want to progress:</h3>
 
   <div id="GSG_nextstepchoice">
     <a href="openvino_docs_get_started_get_started_scripts.html" >
        <h4>One-command demo 		</h4>
        <p>Execute just one command and watch all the steps happening before your eyes. </p>
     </a>  		
     <a href="openvino_docs_get_started_get_started_demos.html" >
        <h4>Step-by-step demo		</h4>
        <p>Follow the step-by-step instructions to execute simple tasks with OpenVINO. </p>
     </a>
     <a href="tutorials.html" >
        <h4>Python Tutorials		</h4>
        <p>Learn from a choice of interactive Python tutorials targeting typical OpenVINO use cases.	</p>
     </a> 		
     <a href="workbench_docs_Workbench_DG_Introduction.html" >
        <h4>DL Workbench		</h4>
        <p>Use a web-based version of OpenVINO with a Graphical User Interface. Installing a DL Workbench container is required. </p>
     </a> 
     <a href="openvino_docs_IE_DG_Samples_Overview.html" >
        <h4>OpenVINO samples	</h4>
        <p>See ready-made applications explaining OpenVINO features and various use-cases.		</p>
     </a> 
     <a href="openvino_docs_IE_DG_Samples_Overview.html" >
        <h4>Reference Implementation For Speech Recognition Apps</h4>
        <p>Use a speech recognition demo and Kaldi* model conversion tool as reference. </p>
     </a>
     <a href="http://devcloud.intel.com/edge/" >
        <h4>Intel® DevCloud 	</h4>
        <p>Develop, test, and run your OpenVINO solution for free on a cluster of the latest Intel® hardware. </p>
     </a> 
   </div>
   <div style="clear:both;"> </div>

@endsphinxdirective